// filter.h - Advanced Filter
//
// Old Mail Arrangement Plug-in for Becky! 2
// Copyright (C) 2000 by Tietew
//
#pragma once
#include "utys.h"

// dwFlag value
#define FILTER_FROM			0x0001
#define FILTER_TO			0x0002
#define FILTER_SUBJECT		0x0004
#define FILTER_PRIORITY		0x0008
#define FILTER_COLORLABEL	0x0010
#define FILTER_STATUS		0x0020
#define FILTER_SIZE			0x0040

// Text filter item
struct FILTERTEXT
{
	String text;
	bool bNot;
	bool bRegExp;
	FILTERTEXT() : bNot(false), bRegExp(false) { }
};

// One filter
struct FILTERITEM
{
	String name;			// filter name
	DWORD dwFlag;
	FILTERTEXT from;
	FILTERTEXT to;
	FILTERTEXT subject;
	int nPriority;
	int nPriorityUnit;
	COLORREF color;
	int nStatus;
	int nSize;
	int nSizeUnit;
	FILTERITEM(String name)
		: name(name)
	{
		dwFlag = nPriority = nPriorityUnit = color
			= nStatus = nSize = nSizeUnit = 0;
	}
};

// Advanced Filter information
struct FILTERINFO
{
	typedef list<FILTERITEM> TList;
	TList v;
};

// Advanced Filter setting dialog
struct FILTERDLGINFO
{
	FILTERINFO fi;
	int nCurSel;
};

void GetFilterItem(FILTERINFO& fi, String path, int i);
void SetFilterItem(const FILTERITEM& item, int i, String path);
BOOL CALLBACK FilterProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);

void MarkMoreButton(HWND hwnd, UINT uID, const FILTERINFO& fi);
bool AdvancedFilter(const INDEXINFO& info, const FILTERINFO& fi);
