// utys.h
//
// Old Mail Arrangement Plug-in for Becky! 2
// Copyright (C) 2000 by Tietew
//
#pragma once

// Folder.idx information
struct INDEXINFO
{
	DWORD dwOffset;			// offset of bmf file
	String id;				// mail id
	String bmf;				// filebase of bmf contains this mail
	String subject;			// subject
	String from;			// from address(es)
	String to;				// to address(es)
	String messageid;		// Message-Id
	String reference;		// reference
	DWORD dwDate;			// sent date (time_t)
	DWORD dwRecvDate;		// received date (time_t)
	DWORD dwRouteDate;		// routed date (time_t)
	DWORD dwSize;			// octet-size
	DWORD dwStatus;			// status
	COLORREF color;			// color label
	int nPriority;			// priority
	String refid;			// referenced mail id
	String lang;			// language
};

// Folder.idx parser
class CFolderIndex
{
	HANDLE m_hFile;
	HANDLE m_hMap;
	LPCSTR m_pch;
	DWORD m_dwSize;
	DWORD m_dwCurOffset;
public:
	CFolderIndex(String folder);
	~CFolderIndex();
	int Failed() const
	{
		return m_hFile == INVALID_HANDLE_VALUE ? (m_dwCurOffset == 0 ? 1 : 2) : 0;
	}
	String GetLine();
	bool NextLine();
	int GetPercent() const
	{
		return m_dwCurOffset * 100 / m_dwSize;
	}
	static void Parse(LPCSTR line, INDEXINFO& info);
};

// Becky's windows
class CBeckyWindow
{
public:
	HWND hwndMain, hwndTree;
	HWND hwndList, hwndListHead;
	HWND hwndView, hwndStatus;
	CBeckyWindow();
};

void PseudoDrawFocusRect(HDC hdc, LPRECT prc);
int MyMessageBox(HWND hwnd, UINT uID, UINT uType);
void GetVersionString(LPSTR pszVersion);
String token(LPCSTR& str);
DWORD hex32(LPCSTR& str);
String hex32(DWORD dw);
